-- DorHUD by DorentuZ` -- http://steamcommunity.com/id/dorentuz/
--   Hitmarkers module by BangL
--
-- This Source Code Form is subject to the terms of the Mozilla Public
-- License, v. 2.0. If a copy of the MPL was not distributed with this
-- file, You can obtain one at http://mozilla.org/MPL/2.0/.

local module = D:module('hitmarkers')

CopDamage.__name = "CopDamage"

module:hook(CopDamage, "damage_bullet", function(self, attack_data)
	return self:hitmarker_hub(attack_data, "damage_bullet")
end)

module:hook(CopDamage, "damage_explosion", function(self, attack_data)
	return self:hitmarker_hub(attack_data, "damage_explosion")
end)

module:hook(CopDamage, "damage_melee", function(self, attack_data)
	return self:hitmarker_hub(attack_data, "damage_melee")
end)

module:hook(CopDamage, "hitmarker_hub", function(self, attack_data, original_function)
	local was_alive = not self._dead
	local result = module:call_orig(CopDamage, original_function, self, attack_data)
	if was_alive and attack_data.attacker_unit == managers.player:player_unit() then
		managers.hud:confirm_hit(not self._head_body_name or not attack_data.col_ray.body or attack_data.col_ray.body:name() == self._ids_head_body_name, self._dead)
	end
	return result
end)
